Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.google.common.cache
Class ForwardingCache<K,V>

    java.lang.Object
      com.google.common.collect.ForwardingObject
          com.google.common.cache.ForwardingCache<K,V>

All Implemented Interfaces:
  Cache<K,V>

Direct Known Subclasses:
  ForwardingCache.SimpleForwardingCache, ForwardingLoadingCache

    @Beta
    public abstract class ForwardingCache<K,V>

extends ForwardingObject
implements Cache<K,V>

A cache which forwards all its method calls to another cache. Subclasses should override one or more methods to modify the behavior of the backing cache as desired per the decorator pattern.

Since:
  10.0
Author:
  Charles Fry

Nested Class Summary
`static class` | `ForwardingCache.SimpleForwardingCache<K,V>` A simplified version of `ForwardingCache` where subclasses can pass in an already constructed `Cache` as the delegete.

Constructor Summary
`protected` | `ForwardingCache()` Constructor for use by subclasses.

Method Summary
`ConcurrentMap<K,V>` | `asMap()` Returns a view of the entries stored in this cache as a thread-safe map.
`void` | `cleanUp()` Performs any pending maintenance operations needed by the cache.
`protected abstract Cache<K,V>` | `delegate()` Returns the backing delegate instance that methods are forwarded to.
`V` | `get(K key, Callable<? extends V> valueLoader)` Returns the value associated with `key` in this cache, obtaining that value from `valueLoader` if necessary.
`ImmutableMap<K,V>` | `getAllPresent(Iterable<?> keys)` Returns a map of the values associated with `keys` in this cache.
`V` | `getIfPresent(Object key)` Returns the value associated with `key` in this cache, or `null` if there is no cached value for `key`.
`void` | `invalidate(Object key)` Discards any cached value for key `key`.
`void` | `invalidateAll()` Discards all entries in the cache.
`void` | `invalidateAll(Iterable<?> keys)` Discards any cached values for keys `keys`.
`void` | `put(K key, V value)` Associates `value` with `key` in this cache.
`void` | `putAll(Map<? extends K,? extends V> m)` Copies all of the mappings from the specified map to the cache.
`long` | `size()` Returns the approximate number of entries in this cache.
`CacheStats` | `stats()` Returns a current snapshot of this cache's cumulative statistics.

Methods inherited from class com.google.common.collect.ForwardingObject
`toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### ForwardingCache

    protected ForwardingCache()

  Constructor for use by subclasses.

Method Detail

### delegate

    protected abstract Cache<K,V> delegate()

  Description copied from class: `ForwardingObject`
  Returns the backing delegate instance that methods are forwarded to. Abstract subclasses generally override this method with an abstract method that has a more specific return type, such as `ForwardingSet.delegate()`. Concrete subclasses override this method to supply the instance being decorated.

  Specified by:
    `delegate` in class `ForwardingObject`

### getIfPresent

    @Nullable
    public V getIfPresent(Object key)

  Description copied from interface: `Cache`
  Returns the value associated with `key` in this cache, or `null` if there is no cached value for `key`.

  Specified by:
    `getIfPresent` in interface `Cache<K,V>`
  Since:
    11.0

### get

    public V get(K key,
                 Callable<? extends V> valueLoader)
          throws ExecutionException

  Description copied from interface: `Cache`
  Returns the value associated with `key` in this cache, obtaining that value from `valueLoader` if necessary. No observable state associated with this cache is modified until loading completes. This method provides a simple substitute for the conventional "if cached, return; otherwise create, cache and return" pattern.

  Warning: as with `CacheLoader.load(K)`, `valueLoader` must not return `null`; it may either return a non-null value or throw an exception.

  Specified by:
    `get` in interface `Cache<K,V>`
  Throws:
    `ExecutionException` - if a checked exception was thrown while loading the value
  Since:
    11.0

### getAllPresent

    public ImmutableMap<K,V> getAllPresent(Iterable<?> keys)

  Description copied from interface: `Cache`
  Returns a map of the values associated with `keys` in this cache. The returned map will only contain entries which are already present in the cache.

  Specified by:
    `getAllPresent` in interface `Cache<K,V>`
  Since:
    11.0

### put

    public void put(K key,
                    V value)

  Description copied from interface: `Cache`
  Associates `value` with `key` in this cache. If the cache previously contained a value associated with `key`, the old value is replaced by `value`.

  Prefer `Cache.get(Object, Callable)` when using the conventional "if cached, return; otherwise create, cache and return" pattern.

  Specified by:
    `put` in interface `Cache<K,V>`
  Since:
    11.0

### putAll

    public void putAll(Map<? extends K,? extends V> m)

  Description copied from interface: `Cache`
  Copies all of the mappings from the specified map to the cache. The effect of this call is equivalent to that of calling `put(k, v)` on this map once for each mapping from key `k` to value `v` in the specified map. The behavior of this operation is undefined if the specified map is modified while the operation is in progress.

  Specified by:
    `putAll` in interface `Cache<K,V>`
  Since:
    12.0

### invalidate

    public void invalidate(Object key)

  Description copied from interface: `Cache`
  Discards any cached value for key `key`.

  Specified by:
    `invalidate` in interface `Cache<K,V>`

### invalidateAll

    public void invalidateAll(Iterable<?> keys)

  Description copied from interface: `Cache`
  Discards any cached values for keys `keys`.

  Specified by:
    `invalidateAll` in interface `Cache<K,V>`
  Since:
    11.0

### invalidateAll

    public void invalidateAll()

  Description copied from interface: `Cache`
  Discards all entries in the cache.

  Specified by:
    `invalidateAll` in interface `Cache<K,V>`

### size

    public long size()

  Description copied from interface: `Cache`
  Returns the approximate number of entries in this cache.

  Specified by:
    `size` in interface `Cache<K,V>`

### stats

    public CacheStats stats()

  Description copied from interface: `Cache`
  Returns a current snapshot of this cache's cumulative statistics. All stats are initialized to zero, and are monotonically increasing over the lifetime of the cache.

  Specified by:
    `stats` in interface `Cache<K,V>`

### asMap

    public ConcurrentMap<K,V> asMap()

  Description copied from interface: `Cache`
  Returns a view of the entries stored in this cache as a thread-safe map. Modifications made to the map directly affect the cache.

  Specified by:
    `asMap` in interface `Cache<K,V>`

### cleanUp

    public void cleanUp()

  Description copied from interface: `Cache`
  Performs any pending maintenance operations needed by the cache. Exactly which activities are performed -- if any -- is implementation-dependent.

  Specified by:
    `cleanUp` in interface `Cache<K,V>`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2010-2012. All Rights Reserved.